//
//		wargame.js
//
//

// espace de noms pour tout le script
var Wargame = {

	currentTile: 'plain',
	selectTile: function selectTile( tile ) {
		if (tile != Wargame.currentTile) {
			$ref.currentTile.innerHTML = tile;
			$ref.currentTile.className = tile;
			Wargame.currentTile = tile;
		}
		return tile;
	},
	
	canDraw: false,
	
	// sous-espace de noms pour tous les gestionnaires d'evenements
	handle: {
		
		tile: function select(ev) {
			if ('LI' == browser.getEventTarget(ev).tagName) {
				Wargame.selectTile(browser.getEventTarget(ev).className);
			}
		},
		mousedown: function mousedown(ev) {
			if ('TD' == browser.getEventTarget(ev).tagName) {
				Wargame.canDraw = true;
			}
			browser.stopEvent(ev);
		},
		mousemove: function mousemove(ev) {
			if ('TD' == browser.getEventTarget(ev).tagName && Wargame.canDraw) {
				browser.getEventTarget(ev).className = Wargame.currentTile;
			}
		},
		click: function click(ev) {
			if ('TD' == browser.getEventTarget(ev).tagName) {
				browser.getEventTarget(ev).className = Wargame.currentTile;
			}
		}
	}
};

////////////////////////////////////////////////////////////////////////

// references aux elements souvent utilises
var $ref = {
	tileSelect: null,
	currentTile: null,
	map: null
};

// gestion des incompatibilites cross-browser
if (window.addEventListener) {
	// navigateurs standards
	browser = {
		addListener: function addListener( object, type, listener ) {
			object.addEventListener(type, listener, false);
		},
		getEventTarget: function getEventTarget( ev ) {
			return ev.target;
		},
		stopEvent: function stopEvent( ev ) {
			ev.preventDefault();
		}
	};
} else {
	// IE
	browser = {
		addListener: function addListener( object, type, listener ) {
			object.attachEvent('on' + type, listener);
		},
		getEventTarget: function getEventTarget( ev ) {
			return ev.srcElement;
		},
		stopEvent: function stopEvent( ev ) {
			ev.returnValue = false;
		}
	};
};

////////////////////////////////////////////////////////////////////////

// ajout des gestionnaires une fois que tous les elements sont charges
browser.addListener(window, 'load', function windowLoad() {
	var $currentTile =
		$ref.currentTile = document.getElementById('current-tile');
	$currentTile.innerHTML = 'plain';
	$currentTile.className = 'plain';
	
	var handlers = Wargame.handle;
	
	var $tileSelect =
		$ref.tileSelect = document.getElementById('tile-select');
	browser.addListener($tileSelect, 'click', handlers.tile);
	
	var $map =
		$ref.map = document.getElementById('map');
	var $tbody = $map.getElementsByTagName('tbody').item(0);
	browser.addListener($tbody, 'mousedown', handlers.mousedown);
	browser.addListener($tbody, 'mousemove', handlers.mousemove);
	browser.addListener($tbody, 'click', handlers.click);
	
	browser.addListener(document.body, 'mouseup', function bodyMouseup() {
		Wargame.canDraw = false;
	});
});
